// QamQDpskView.cpp : implementation of the CQamQDpskView class
//

#include "stdafx.h"
#include "QamQDpsk.h"

#include "QamQDpskDoc.h"
#include "QamQDpskView.h"
#include ".\qamqdpskview.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

int iResultFlag=1;
unsigned char Code1[500],Code2[500];
unsigned char c1,c2,c3;
double pi = 3.1415926535;
int iYY;
int xvalue,yvalue;
int iFlag;
double degree1 = 3.1415926535 / 180;

int xpixel = 0;
double ampl1;

int a_max = 800;
int phase;
int Kvalue = 1;

CString  strCodeArr[30]={
"dummy1",
"LESSON",
"SCREEN",
"CANADA",
"TSHIRT",
"MIRROR",
"SHADOW",
"BATMAN",
"SPIDER",
"SHAKER",
"PEPPER",
"WALLET",
"PENCIL",
"MOBILE",
"IMPULS",
"MATRIX",
"MODULE",
"FSKASK",
"PLAYER",
"WINDOW",
"HIGHER",
"FILTER",
"HOTKEY",
"YELLOW",
"SCHOOL",
};



// CQamQDpskView

IMPLEMENT_DYNCREATE(CQamQDpskView, CView)

BEGIN_MESSAGE_MAP(CQamQDpskView, CView)
	ON_COMMAND(ID_BUT_RESULT, OnResultFlag)
	ON_COMMAND(ID_BUT_MINUS, OnMinus)
	ON_COMMAND(ID_BUT_PLUS, OnPlus)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

// CQamQDpskView construction/destruction

CQamQDpskView::CQamQDpskView()
{
	// TODO: add construction code here
}

CQamQDpskView::~CQamQDpskView()
{
}

BOOL CQamQDpskView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}



// CQamQDpskView printing

BOOL CQamQDpskView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CQamQDpskView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CQamQDpskView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CQamQDpskView diagnostics

#ifdef _DEBUG
void CQamQDpskView::AssertValid() const
{
	CView::AssertValid();
}

void CQamQDpskView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CQamQDpskDoc* CQamQDpskView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CQamQDpskDoc)));
	return (CQamQDpskDoc*)m_pDocument;
}
#endif //_DEBUG


// CQamQDpskView message handlers




// CQamQDpskView drawing
void CQamQDpskView::OnDraw(CDC* pDC)
{
	CQamQDpskDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)		return;
 // TODO: add draw code for native data here

	 pDC->SetMapMode( MM_TWIPS );
	 pDC->SelectObject(&m_font);

	int xx;
	unsigned char chx;
    CString str;
	int iBitpointer;


#define x0 300
#define x0_max 15800
#define y0 -800


#define Eindegree  1
int nrmax = 20;


	pDC->MoveTo(x0-100,-40);
	pDC->LineTo(x0_max,-40);
	pDC->LineTo(x0_max,-11000);
	pDC->LineTo(x0-100,-11000);
	pDC->LineTo(x0-100,-40);
	pDC->TextOut(x0+100,-10750,"Orgler: telecommunication exercises");

	
	CString strCode1,strCode2;

	strCode1 = strCodeArr[Kvalue];
	int laenge = strCode1.GetLength();

	laenge = 6;
	int iPosition;
	memset(Code1,'0',100);

	iPosition = 0;
	xx=0;                    
    while(xx < laenge)
	{
    Code1[iPosition]='0';				// StartBit
	chx = strCode1.GetAt(xx);
	iPosition++; if(chx & 0x01) Code1[iPosition]='1';
	iPosition++; if(chx & 0x02) Code1[iPosition]='1';
	iPosition++; if(chx & 0x04) Code1[iPosition]='1';
	iPosition++; if(chx & 0x08) Code1[iPosition]='1';
	iPosition++; if(chx & 0x10) Code1[iPosition]='1';
	iPosition++; if(chx & 0x20) Code1[iPosition]='1';
	iPosition++; if(chx & 0x40) Code1[iPosition]='1';
	iPosition++; if(chx & 0x80) Code1[iPosition]='1';

	iPosition++; Code1[iPosition]= '1';  // Stopbit
	iPosition++; 
	xx++;	
	}
    Code1[60]= 0; 


	strCode2 = strCodeArr[Kvalue+1];
	memset(Code2,'0',100);
	iPosition = 0;
	xx=0;                    
    while(xx < 4)
	{
    Code2[iPosition]='0';		// StartBit
	chx = strCode2.GetAt(xx);
	iPosition++; if(chx & 0x01) Code2[iPosition]='1';
	iPosition++; if(chx & 0x02) Code2[iPosition]='1';
	iPosition++; if(chx & 0x04) Code2[iPosition]='1';
	iPosition++; if(chx & 0x08) Code2[iPosition]='1';
	iPosition++; if(chx & 0x10) Code2[iPosition]='1';
	iPosition++; if(chx & 0x20) Code2[iPosition]='1';
	iPosition++; if(chx & 0x40) Code2[iPosition]='1';
	iPosition++; if(chx & 0x80) Code2[iPosition]='1';

	iPosition++; Code2[iPosition]= '1';  // Stopbit
	iPosition++; 
	xx++;	
	}
	Code2[40]= 0; 
	
	int nr=0;
	int bitperiode = 900;

	int bitcount;

    str.Format("Kvalue%d",Kvalue);	pDC->TextOut(x0+10000,-100,str);
	iYY  = -1000;

	//*** Signal QAM ********************
	bitcount	= 0;
	nr			= 0;
	iBitpointer	= 0;
	phase       = 0;
	xpixel      = 0;
	iFlag       = 0;

    pDC->TextOut(x0+100,y0 + iYY + a_max + 600,"QAM Signal Bytes from RS232 Startbit=0 8 databits Stopbit=1");

	str.Format("%s %s",strCode1,Code1);
	if(iResultFlag==1) pDC->TextOut(x0+100,y0 + iYY + a_max + 300,str);

    nrmax=20;
    while(nr < nrmax)
	{
		c1 = Code1[iBitpointer++]; c2=Code1[iBitpointer++]; c3=Code1[iBitpointer++]; 
		if ( c1 == '0' && c2 == '0' && c3 == '0'  ) { phase =  225; a_max =   560; }
		if ( c1 == '0' && c2 == '0' && c3 == '1'  ) { phase =  225; a_max =  1000; }
		if ( c1 == '0' && c2 == '1' && c3 == '0'  ) { phase =  325; a_max =   560; }
		if ( c1 == '0' && c2 == '1' && c3 == '1'  ) { phase =  325; a_max =  1000; }
		if ( c1 == '1' && c2 == '0' && c3 == '0'  ) { phase =  135; a_max =   560; }
		if ( c1 == '1' && c2 == '0' && c3 == '1'  ) { phase =  135; a_max =  1000; }
		if ( c1 == '1' && c2 == '1' && c3 == '0'  ) { phase =   45; a_max =   560; }
		if ( c1 == '1' && c2 == '1' && c3 == '1'  ) { phase =   45; a_max =  1000; }

			if(iResultFlag==1) 
			{ 
			yvalue = y0 + iYY;
			str.Format("%c%c%c",c1,c2,c3);
			pDC->TextOut(x0 + xpixel,yvalue,str);
			}

		DrawSinus(phase,pDC);   // 2 periodes
		DrawSinus(phase,pDC);
 	nr++;
	}

	//********** carrier  ************* 
	a_max = 800;
	iYY += -2000;
	pDC->TextOut(x0+12000,y0 + iYY + a_max + 300,"carrier");
	pDC->MoveTo(x0,y0 + iYY);
    xpixel = 0;
	nr    = 0;

    while(nr < 20)
	{ 
    iFlag = 0;
	DrawSinus(0,pDC);
	DrawSinus(0,pDC);
	nr++;
	}
	pDC->MoveTo(x0,y0 + iYY);           // draw baseline
	pDC->LineTo(x0 + xpixel,y0 + iYY);



	//*** Signal 4-QDPSK  ********************
	iYY += -2000;
	pDC->TextOut(x0+100,y0 + iYY - a_max - 300,"QDPSK");
	str.Format("%s %s",strCode2,Code2);
	if(iResultFlag==1) pDC->TextOut(x0+100,y0 + iYY - a_max - 100,str);

	xpixel      = 0;
	bitcount    = 0;
	nr          = 0;
	iBitpointer = 0;
	phase       = 0;
	iFlag		= 0;
	
    while(nr < nrmax)
	{
		c1 = Code1[iBitpointer++]; c2=Code1[iBitpointer++]; 
		if ( c1 == '0' && c2 == '0' ) phase += 0;
		if ( c1 == '1' && c2 == '0' ) phase += 90;     // ff
		if ( c1 == '1' && c2 == '1' ) phase += 180;    // ff
		if ( c1 == '0' && c2 == '1' ) phase += 270;    // ff

		if(phase >= 360) phase -= 360;
			if(iResultFlag==1) 
			{ 
			xvalue = x0 + xpixel; 
			yvalue = y0 + iYY;
			str.Format("%c%c",c1,c2);
			pDC->TextOut(xvalue,yvalue,str);
			}

	
		DrawSinus(phase,pDC);   // draw 2 periodes 
		DrawSinus(phase,pDC);
	nr++;
	}
 

  xpixel = 0;
//********************** QAM **********************
  	iYY += -3000;

     phase =  225; a_max =  560;
     Referenz(pDC,"000");

	 phase =  225; a_max = 1000;
     Referenz(pDC,"001");

	  phase =  325; a_max =   560; 
     Referenz(pDC,"010");

	 phase =  325; a_max =  1000; 
     Referenz(pDC,"011");

     phase =  135; a_max = 560; 
     Referenz(pDC,"100");

	 phase =  135; a_max =  1000; 
     Referenz(pDC,"101");

     phase =  45; a_max = 560; 
     Referenz(pDC,"110");

	 phase =  45; a_max =  1000; 
     Referenz(pDC,"111");

     xpixel += 1000;

	//**************************  0 degree **********************
    a_max =  800;  
 	pDC->TextOut(x0+xpixel,y0 + iYY + a_max + 300,"0 degree");
	pDC->MoveTo(x0,y0 + iYY);

		iFlag = 0;
		DrawSinus(0,pDC);   
		DrawSinus(0,pDC);

	
     xpixel += 800;
  	//********** 90 degree  ************* 

	pDC->TextOut(x0+xpixel,y0 + iYY + a_max + 300,"90 degree");
	pDC->MoveTo(x0,y0 + iYY);
 
		iFlag = 0;
		DrawSinus(90,pDC);  
		DrawSinus(90,pDC);

     xpixel += 800;

	 //**********  180 degree  ************* 
	pDC->TextOut(x0+xpixel,y0 + iYY + a_max + 300,"180 degree");
	pDC->MoveTo(x0,y0 + iYY);

		iFlag = 0;
		DrawSinus(180,pDC); 
		DrawSinus(180,pDC);

     xpixel += 800;
  	
	 //********** 270 degree  ************* 
	pDC->TextOut(x0+xpixel,y0 + iYY + a_max + 300,"270 degree");
	pDC->MoveTo(x0,y0 + iYY);
		iFlag = 0;
		DrawSinus(270,pDC); 
		DrawSinus(270,pDC);


  iYY += -800;	pDC->TextOut(x0+9000,y0 + iYY,"QDPSK DiBit  phase skip");
  iYY += -200;	pDC->TextOut(x0+9000,y0 + iYY,"      0 0          0");
  iYY += -200;	pDC->TextOut(x0+9000,y0 + iYY,"      1 0        +90");
  iYY += -200;	pDC->TextOut(x0+9000,y0 + iYY,"      1 1       +180");
  iYY += -200;	pDC->TextOut(x0+9000,y0 + iYY,"      0 1       +270"); 
 
}


void CQamQDpskView::DrawSinus(int phistart,CDC* pDrawC)
{
int xx=0;
double dphi;

    dphi = (phistart *  pi) / 180;
	while(xx < 360)
	{
    ampl1 = a_max * sin(xx * degree1 + dphi);
	xvalue =   x0 + xpixel;
	yvalue =   y0 + (int)ampl1 + iYY;

	if(iFlag) pDrawC->LineTo(xvalue,yvalue);
	else pDrawC->MoveTo(xvalue,yvalue);
	iFlag = 1;
	xpixel++; 
	xx++;
	}

}

void CQamQDpskView::Referenz(CDC* pDrawC,CString str1)
{
CString str;
	str.Format("%3d ",phase);

	pDrawC->TextOut(x0+100+xpixel,y0 + iYY + a_max + 300,str);
	pDrawC->TextOut(x0+100+xpixel,y0 + iYY - a_max -50,str1);
	pDrawC->MoveTo(x0,y0 + iYY);
 
		iFlag = 0;
		DrawSinus(phase,pDrawC);   
		DrawSinus(phase,pDrawC);
	
     xpixel += 350;
}


void CQamQDpskView::OnResultFlag() 
{
	if(iResultFlag==1)iResultFlag=0; else iResultFlag=1;
		Invalidate();
}

void CQamQDpskView::OnMinus() 
{
	if(Kvalue > 1) Kvalue--;
	Invalidate();
}

void CQamQDpskView::OnPlus() 
{
  if(Kvalue < 20) Kvalue++;	
  	Invalidate();
}
void CQamQDpskView::OnInitialUpdate()
{
	CView::OnInitialUpdate();
	// TODO: 
	memset(&logfont, 0, sizeof(logfont));
	logfont.lfHeight= 6*36;
	logfont.lfWidth = 5*36;
//	logfont.lfWeight= FW_BOLD;
	CString szFont;
	szFont="Courier New";           // TrueType font
	lstrcpy(logfont.lfFaceName, szFont);
	VERIFY(m_font.CreateFontIndirect(&logfont));
	SetFont( &m_font );	
}
